use colored::Colorize;
use std::f64::consts;
use std::io::{stdout, Write};
use std::process::exit;

fn rainbow(freq: f64, i: f64) -> (u8, u8, u8) {
    let red = ((freq * i).sin() * 127.0) as u8 + 128;
    let green = ((freq * i + 2.0 * consts::PI / 3.0).sin() * 127.0) as i16 + 128;
    let blue = ((freq * i + 4.0 * consts::PI / 3.0).sin() * 127.0) as i16 + 128;
    (red as u8, green as u8, blue as u8)
}

pub fn print_rainbow(line: &str, freq: f64, seed: f64, spread: f64, invert: bool) {
    let t = line
        .chars()
        .enumerate()
        .map(|(i, c)| {
            let (r, g, b) = rainbow(freq, seed + i as f64 / spread);
            if invert {
                if c == '\n' || c == '\r' {
                    c.to_string().normal()
                } else {
                    c.to_string().on_truecolor(r, g, b)
                }
            } else {
                c.to_string().truecolor(r, g, b)
            }
        })
        .fold("".to_string(), |acc, v| format!("{}{}", acc, v));
    if stdout().write_all(t.as_bytes()).is_err() {
        exit(0);
    }
}
